/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.sunspotworld;

import com.sun.spot.io.j2me.radiogram.RadiogramConnection;
import com.sun.spot.peripheral.Battery.*;
import com.sun.spot.sensorboard.EDemoBoard;
import com.sun.spot.sensorboard.io.IScalarInput;
import com.sun.spot.util.Utils;
import javax.microedition.io.Connector;
import javax.microedition.io.Datagram;

/**
 *
 * @author Project
 */
class CarMonByteId implements Runnable {

   String location;
   Thread t;
   int portNumber;
   int locAsNo;

   CarMonByteId(String threadname, int portNo, int locationAsNumber) {
      location = threadname;
      t = new Thread(this, location);
      portNumber = portNo;
      locAsNo = locationAsNumber;
      System.out.println("New thread: " + t);
      t.start();
   }
   // -------------------------------------------------------------------
   // Constants
   // -------------------------------------------------------------------
   private static final int SAMPLE_PERIOD = 10 * 1000;   // milliseconds
   // -------------------------------------------------------------------

   // -------------------------------------------------------------------
   // entry point for carbon monoxide sampler thread
   // -------------------------------------------------------------------
   public void run() {

      // ----------------------------------------------------------------
      // Variables and objects
      // ----------------------------------------------------------------
      EDemoBoard test = EDemoBoard.getInstance();
      IScalarInput anologInputs[] = test.getScalarInputs();
      RadiogramConnection rCon = null;
      Datagram dg = null;
      String ourAddress = System.getProperty("IEEE_ADDRESS");
      long now = 0L;
      int inputSample = 0;
      double actVoltage = 0.0;
      // ----------------------------------------------------------------

      // ----------------------------------------------------------------
      // get and push IEEE Address to terminal
      // ----------------------------------------------------------------
      System.out.println("Starting carbon monoxide sampler on " +
              ourAddress + " ...");
      // ----------------------------------------------------------------

      System.out.println(location);

      try {
         // Open up a broadcast connection to the host port
         // where the 'on Desktop' portion of this demo is listening
         rCon = (RadiogramConnection) Connector.open(
                 "radiogram://broadcast:" + portNumber
         );
         dg = rCon.newDatagram(200);  // 50 = send 12 bytes of data
      } catch (Exception e) {
         System.err.println(
                 "Caught " + e + " in connection initialisation."
         );
      // System.exit(1);
      }

      // ----------------------------------------------------------------
      // read the current value on the A0 input
      // ----------------------------------------------------------------
      try {
         for (int i = 5; i > 0; i--) {
            now = System.currentTimeMillis();
            inputSample = anologInputs[0].getValue();

            // ----------------------------------------------------------
            // Convert input value to voltage
            // ----------------------------------------------------------
            actVoltage = inputSample * 0.001024 * 3;
            System.out.println("Actual voltage: " + actVoltage);
            // ----------------------------------------------------------

            // ----------------------------------------------------------
            // Package time & sensor data into a radio datagram & send
            // ----------------------------------------------------------
            dg.reset();
            dg.writeLong(now);
            dg.writeByte(5);
            dg.writeUTF(location);
            dg.writeInt(0);
            dg.writeDouble(actVoltage);
            rCon.send(dg);
            // ----------------------------------------------------------

            // ----------------------------------------------------------
            // Go to sleep to conserve battery
            // ----------------------------------------------------------
            Utils.sleep(SAMPLE_PERIOD
                        - (System.currentTimeMillis() - now));
         // -------------------------------------------------------------

         }

      } catch (Exception e) {
         System.out.println("Problem reading Pin to monitor");
      }

      // ----------------------------------------------------------------
      // Message before exiting thread (trouble shooting only)
      // ----------------------------------------------------------------
      System.out.println(location + " exiting.");
   // -------------------------------------------------------------------
   }
}
