/* **********************************************************************
 * Author      :  Severin Willisch
 * email       :  d9840087@mail.connect.usq.edu.au
 * Student No. :  0039840087
 * Purpose     :  Project for Semester 1 & 2, 2009
 * Purpose     :  09-036 Programming Sun SPOTs in JAVA
 * **********************************************************************
 */

/* **********************************************************************
 * Purpose     :  This class includes all specific functions of an ...
 * Purpose     :  alarm collector mote.
 * **********************************************************************
 */

package org.sunspotworld;

import com.sun.spot.sensorboard.EDemoBoard;
import com.sun.spot.sensorboard.EDemoController;
import com.sun.spot.sensorboard.io.InputPin;
import com.sun.spot.sensorboard.io.PinDescriptor;


class CollectorAlarmMote extends CollectorMote {
   // ===================================================================
   // Instance variables
   // -------------------------------------------------------------------
   private PinDescriptor AlarmTriggerInput;
   private EDemoBoard test;
   private EDemoController testController;
   private InputPin pin;
   // ===================================================================

   // ===================================================================
   // methods to access instance variables, setter methods
   // ===================================================================
   void setPinStatus(InputPin setPin){
      pin = setPin;
   }
   // ===================================================================

   // ===================================================================
   // methods to access instance variables, getter methods
   // ===================================================================
   InputPin getPinStatus(){
      return pin;
   }

   // ===================================================================


   // ===================================================================
   // All other methods
   // ===================================================================
   void initAlarm(){
      // ================================================================
      // initialise alarm capability of mote
      // ----------------------------------------------------------------
      AlarmTriggerInput = EDemoController.D2;
      test = EDemoBoard.getInstance();
      testController = test.getEDemoController();
      pin = new InputPin(AlarmTriggerInput, testController);
      testController.setPinDirection(AlarmTriggerInput, false);
      testController.enablePinChangeInterrupts(pin);
      // ================================================================

   } // end initAlarm()

   boolean pinStatus(){
      // ================================================================
      // Check if input is low on D2. Low means no alarm triggered
      // ----------------------------------------------------------------
      return (pin.isLow());
      // ================================================================

   }// end pinStatus()

   void setEnablePinChangeInterruptsToTrue(){
      testController.enablePinChangeInterrupts(pin);
   } // end setEnablePinChangeInterruptsToTrue()
   

} // end CollectorAlarmMote class
