/* **********************************************************************
 * Author      :  Severin Willisch
 * email       :  d9840087@mail.connect.usq.edu.au
 * Student No. :  0039840087
 * Purpose     :  Project for Semester 1 & 2, 2009
 * Purpose     :  09-036 Programming Sun SPOTs in JAVA
 * **********************************************************************
 */

/* **********************************************************************
 * Purpose     :  This class includes all the specific functions of a ...
 * Purpose     :  battery collector mote.
 * **********************************************************************
 */

package org.sunspotworld;

import com.sun.spot.peripheral.IBattery;
import com.sun.spot.peripheral.Spot;

class CollectorBattMote extends CollectorMote {
   // ===================================================================
   // Instance variables
   // -------------------------------------------------------------------
   private int currentBattLevel = 0;         // current battery level
   private int previousBattLevel = 0;        // previous battery level
   private IBattery battStatus;              // init battery capacity;
   // ===================================================================

   // ===================================================================
   // methods to access instance variables, setter methods
   // ===================================================================
   void setCurrentBatt(int setCurBatt){
      currentBattLevel = setCurBatt;
   }

   void setPreviousBatt(int setPrevBatt){
      previousBattLevel = setPrevBatt;
   }
   // ===================================================================

   // ===================================================================
   // methods to access instance variables, getter methods
   // ===================================================================
   int getCurrentBatt(){
      return currentBattLevel;
   }

   int setPreviousBatt(){
      return previousBattLevel;
   }
   // ===================================================================


   // ===================================================================
   // All other methods
   // ===================================================================
   void initBattMeasurement(){
      // ================================================================
      // initialise battery measurement capability of mote
      // ----------------------------------------------------------------
      battStatus = Spot.getInstance().getPowerController().getBattery();
      // ================================================================

   } // end initLightMeasurement()

   int takeBattSample() {

      // =============================================================
      // take sample of current battery capacity
      // -------------------------------------------------------------
      currentBattLevel = battStatus.getBatteryLevel();
      // =============================================================

      // =============================================================
      // For trouble shooting only
      // -------------------------------------------------------------
      System.out.println("Battery sample taken: " +
              currentBattLevel);
      System.out.println("Previous temp: " +
              previousBattLevel);
      // =============================================================

      return currentBattLevel;

   } // end takeBattSample()

   boolean hasBattChanged(){
      // ================================================================
      // For trouble shooting only
      // ----------------------------------------------------------------
      System.out.println("Check if battery capacity has changed.");
      // ================================================================

      // ================================================================
      // return FALSE if previous batt level equals current batt level
      // ----------------------------------------------------------------
      return currentBattLevel != previousBattLevel;
      // ================================================================

   } // end hasBattChanged()

   void moveCurrentBattToPreviousBatt(){
      // ================================================================
      // For trouble shooting only
      // ----------------------------------------------------------------
      System.out.println("Move current battery level to previous batt.");
      // ================================================================

      // ================================================================
      // move current temp sample to previous sample
      // ----------------------------------------------------------------
      previousBattLevel = currentBattLevel;
      // ================================================================

   } // end moveCurrentBattToPreviousBatt()

} // end of CollectorBattMote
