/* **********************************************************************
 * Author      :  Severin Willisch
 * email       :  d9840087@mail.connect.usq.edu.au
 * Student No. :  0039840087
 * Purpose     :  Project for Semester 1 & 2, 2009
 * Purpose     :  09-036 Programming Sun SPOTs in JAVA
 * **********************************************************************
 */

/* **********************************************************************
 * Purpose     :  This class includes all the specific functions of a ...
 * Purpose     :  carbon mono collector mote.
 * **********************************************************************
 */

package org.sunspotworld;

import com.sun.spot.sensorboard.EDemoBoard;
import com.sun.spot.sensorboard.io.IScalarInput;
import java.io.IOException;

class CollectorCarbonMonoMote extends CollectorMote {
   // ===================================================================
   // Instance variables
   // -------------------------------------------------------------------
   private double currentCarbonMonoLevel = 0;      // in volt
   private double previousCarbonMonoLevel = 0;     // in volt
   private int currentSample = 0;                  // converted to volt
   private EDemoBoard carbonMonoSensor;
   private IScalarInput analogInputs[];
   // ===================================================================

   // ===================================================================
   // methods to access instance variables, setter methods
   // ===================================================================
   void setCurrentCarbonMono(double setCurCarbonMono){
      currentCarbonMonoLevel = setCurCarbonMono;
   }

   void setPreviousCarbonMono(double setPrevCarbonMono){
      previousCarbonMonoLevel = setPrevCarbonMono;
   }

   void setCurrentSample(int setCurSamp){
      currentSample = setCurSamp;
   }
   // ===================================================================

   // ===================================================================
   // methods to access instance variables, getter methods
   // ===================================================================
   double getCurrentCarbonMono(){
      return currentCarbonMonoLevel;
   }

   double getPreviousCarbonMono(){
      return previousCarbonMonoLevel;
   }
   int setCurrentSample(){
      return currentSample;
   }
   // ===================================================================


   // ===================================================================
   // All other methods
   // ===================================================================
   void initCarbonMonoMeasurement(){
      // ================================================================
      // initialise carbon mono measurement capability of mote
      // ----------------------------------------------------------------
      carbonMonoSensor = EDemoBoard.getInstance();
      analogInputs = carbonMonoSensor.getScalarInputs();
      // ================================================================

   } // end of initCarbonMonoMeasurement()

   int takeCarbonMonoSample(){

      try {
         // =============================================================
         // take sample of current carbon mono
         // -------------------------------------------------------------
         currentSample = analogInputs[0].getValue();
         // =============================================================

         // =============================================================
         // For trouble shooting only
         // -------------------------------------------------------------
         System.out.println("Carbon mono sample taken: " +
                 currentSample);
         // =============================================================

      } catch (IOException ex) {
         ex.printStackTrace();
      }

      return currentSample;
   } // end takeCarbonMonoSample()

   double convertCarbonMonoSampleToVolt(int currentSample){
      // ================================================================
      // For trouble shooting only
      // ----------------------------------------------------------------
      System.out.println("Current Sample: " + currentSample);
      // ================================================================


      // ================================================================
      // Convert sample to volt (see Theory of Operation, blue (p. 19))
      // ----------------------------------------------------------------
      currentCarbonMonoLevel = (double)currentSample * 3 / 1024;
      // ================================================================


      // ================================================================
      // For trouble shooting only
      // ----------------------------------------------------------------
      System.out.println("Sample in Volt: " + currentCarbonMonoLevel);
      // ================================================================

      return currentCarbonMonoLevel;
      // ================================================================
      
   } // end convertCarbonMonoSampleToVolt()

   boolean hasCarbonMonoLevelChanged(){
      // ================================================================
      // For trouble shooting only
      // ----------------------------------------------------------------
      System.out.println("Check if carbon mono level has changed.");
      // ================================================================

      // ================================================================
      // return FALSE if previous temp equals current temp
      // ----------------------------------------------------------------
      return currentCarbonMonoLevel != previousCarbonMonoLevel;
      // ================================================================

   } // end hasLightChanged()

   void moveCurrentCarbonMonoToPreviousCarbonMono(){
      // ================================================================
      // For trouble shooting only
      // ----------------------------------------------------------------
      System.out.println("Move current carbon mono to previous.");
      // ================================================================

      // ================================================================
      // move current temp sample to previous sample
      // ----------------------------------------------------------------
      currentCarbonMonoLevel = previousCarbonMonoLevel;
      // ================================================================

   } // end moveCurrentCarbonMonoToPreviousCarbonMono()

} // end of CollectorCarbonMonoMote class
