/* **********************************************************************
 * Author      :  Severin Willisch
 * email       :  d9840087@mail.connect.usq.edu.au
 * Student No. :  0039840087
 * Purpose     :  Project for Semester 1 & 2, 2009
 * Purpose     :  09-036 Programming Sun SPOTs in JAVA
 * **********************************************************************
 */

/* **********************************************************************
 * Purpose     :  This class includes all the specific functions of a ...
 * Purpose     :  light collector mote.
 * **********************************************************************
 */

package org.sunspotworld;

import com.sun.spot.sensorboard.EDemoBoard;
import com.sun.spot.sensorboard.peripheral.ILightSensor;
import java.io.IOException;

class CollectorLightMote extends CollectorMote {
   
   // ===================================================================
   // Instance variables
   // -------------------------------------------------------------------
   private int currentLightLevelAverage = 0;    // current light level
   private int previousLightLevelAverage = 0;   // previous light level
   private ILightSensor lightSensor;
   // ===================================================================

   // ===================================================================
   // methods to access instance variables, setter methods
   // ===================================================================
   void setCurrentLight(int setCurLight){
      currentLightLevelAverage = setCurLight;
   }

   void setPreviousLight(int setPrevLight){
      previousLightLevelAverage = setPrevLight;
   }
   // ===================================================================

   // ===================================================================
   // methods to access instance variables, getter methods
   // ===================================================================
   int getCurrentLight(){
      return currentLightLevelAverage;
   }

   int getPreviousLight(){
      return previousLightLevelAverage;
   }
   // ===================================================================


   // ===================================================================
   // All other methods
   // ===================================================================
   void initLightMeasurement(){
      // ================================================================
      // initialise light measurement capability of mote
      // ----------------------------------------------------------------
      lightSensor = EDemoBoard.getInstance().getLightSensor();
      // ================================================================

   } // end initLightMeasurement()

   int takeLightSample(){

      try {
         // =============================================================
         // take sample of current light level
         // -------------------------------------------------------------
         currentLightLevelAverage = lightSensor.getAverageValue();
         // =============================================================

         // =============================================================
         // For trouble shooting only
         // -------------------------------------------------------------
         System.out.println("Light sample taken: " +
                 currentLightLevelAverage);
         System.out.println("Previous light: " +
                 previousLightLevelAverage);
         // =============================================================

      } catch (IOException ex) {
         ex.printStackTrace();
      }

      return currentLightLevelAverage;
   } // end takeLightSample()


   int convertRawDataToLux(){
      return 2 * currentLightLevelAverage;   // Lux = 2 times raw data

   } // end of convertRawDataToLux()

   boolean hasLightChanged(){
      // ================================================================
      // For trouble shooting only
      // ----------------------------------------------------------------
      System.out.println("Check if light level has changed.");
      // ================================================================

      // ================================================================
      // return FALSE if previous light level equals current light level
      // ----------------------------------------------------------------
      return currentLightLevelAverage != previousLightLevelAverage;
      // ================================================================

   } // end hasLightChanged()

   void moveCurrentLightToPreviousLight(){
      // ================================================================
      // For trouble shooting only
      // ----------------------------------------------------------------
      System.out.println("Move current light level to " +
              "previous light level.");
      // ================================================================

      // ================================================================
      // move current light sample to previous sample
      // ----------------------------------------------------------------
      previousLightLevelAverage = currentLightLevelAverage;
      // ================================================================

   } // end moveCurrentTempToPreviousTemp()

} // end of CollectorLightMote class
