/* **********************************************************************
 * Author      :  Severin Willisch
 * email       :  d9840087@mail.connect.usq.edu.au
 * Student No. :  0039840087
 * Purpose     :  Project for Semester 1 & 2, 2009
 * Purpose     :  09-036 Programming Sun SPOTs in JAVA
 * **********************************************************************
 */

/* **********************************************************************
 * Purpose     :  This class includes all the specific functions of a ...
 * Purpose     :  temperature collector mote.
 * **********************************************************************
 */

package org.sunspotworld;

import com.sun.spot.sensorboard.EDemoBoard;
import com.sun.spot.sensorboard.peripheral.ITemperatureInput;
import java.io.IOException;

class CollectorTempMote extends CollectorMote{

   // ===================================================================
   // Instance variables
   // -------------------------------------------------------------------
   private double currentTemp = 0.0;      // current temperature sample
   private double previousTemp = 0.0;     // previous temperature sample
   private ITemperatureInput temperatureSensor;
   // ===================================================================

   // ===================================================================
   // methods to access instance variables, setter methods
   // ===================================================================
   void setCurrentTemp(double setCurTemp){
      currentTemp = setCurTemp;
   }

   void setPreviousTemp(double setPrevTemp){
      previousTemp = setPrevTemp;
   }
   // ===================================================================

   // ===================================================================
   // methods to access instance variables, getter methods
   // ===================================================================
   double getCurrentTemp(){
      return currentTemp;
   }

   double getPreviousTemp(){
      return previousTemp;
   }
   // ===================================================================


   // ===================================================================
   // All other methods
   // ===================================================================
   void initTemperatureMeasurement(){
      // ================================================================
      // initialise temperature measurement capability of mote
      // ----------------------------------------------------------------
      temperatureSensor = EDemoBoard.getInstance().getADCTemperature();
      // ================================================================
      
   } // end initTemperatureMeasurement()

   double takeTemperatureSample(){
      
      try {
         // =============================================================
         // take sample of current temperature
         // -------------------------------------------------------------
         currentTemp = temperatureSensor.getCelsius();
         // =============================================================

         // =============================================================
         // For trouble shooting only
         // -------------------------------------------------------------
         System.out.println("Temperature sample taken: " + currentTemp);
         System.out.println("Previous temp: " + previousTemp);
         // =============================================================

      } catch (IOException ex) {
         ex.printStackTrace();
      }

      return currentTemp;
   } // end takeTemperatureSample()

   boolean hasTemperatureChanged(){
      // ================================================================
      // For trouble shooting only
      // ----------------------------------------------------------------
      System.out.println("Check if temp has changed.");
      // ================================================================

      // ================================================================
      // return FALSE if previous temp equals current temp
      // ----------------------------------------------------------------
      return currentTemp != previousTemp;
      // ================================================================

   } // end hasTemperatureChanged()

   void moveCurrentTempToPreviousTemp(){
      // ================================================================
      // For trouble shooting only
      // ----------------------------------------------------------------
      System.out.println("Move current temp to previous temp.");
      // ================================================================

      // ================================================================
      // move current temp sample to previous sample
      // ----------------------------------------------------------------
      previousTemp = currentTemp;
      // ================================================================
      
   } // end moveCurrentTempToPreviousTemp()
} // end CollectorTempMote
