/* **********************************************************************
 * Author      :  Severin Willisch
 * email       :  d9840087@mail.connect.usq.edu.au
 * Student No. :  0039840087
 * Purpose     :  Project for Semester 1 & 2, 2009
 * Purpose     :  09-036 Programming Sun SPOTs in JAVA
 * **********************************************************************
 */

/* **********************************************************************
 * Purpose     :  This class is used to broadcast the IEEE address of ...
 * Purpose     :  the host. The interface motes will listen for this ...
 * Purpose     :  broadcast.
 * **********************************************************************
 */

package org.sunspotworld;

import com.sun.spot.peripheral.radio.RadioFactory;
import com.sun.spot.util.IEEEAddress;
import java.util.logging.Level;
import java.util.logging.Logger;

class BroadcastHostAddress implements Runnable {
   String name;                            // name of thread
   Thread t;
   int portNumber;
   
   BroadcastHostAddress(String threadname, int portNo) {
      name = threadname;
      t = new Thread(this, name);
      portNumber = portNo;
      System.out.println("New thread: " + t);
      t.start();
   }

   // ===================================================================
   // Instance variables
   // -------------------------------------------------------------------
   long hostAddress = 0;
   byte hostId = 99;
   // ===================================================================

   public void run() {

      // ================================================================
      // Get and push host address to terminal
      // ----------------------------------------------------------------
      hostAddress = RadioFactory.getRadioPolicyManager().
              getIEEEAddress();
      System.out.println("Our radio address (long)= " +
              IEEEAddress.toDottedHex(hostAddress));
      // ================================================================

      // ================================================================
      // Initial setup for communication
      // ----------------------------------------------------------------
      CommClassHost newBroadcast = new CommClassHost();
      newBroadcast.initBroadcastCom();
      newBroadcast.setPortNumber(portNumber);
      newBroadcast.setLocation("Host");
      newBroadcast.setWriteDataLong(hostAddress);
      newBroadcast.setWriteDataByte(hostId);             // id of host
      // ================================================================

      // ================================================================
      // Open up a broadcast connection
      // ----------------------------------------------------------------
      newBroadcast.tryToOpenBroadcastConnection(true);
      // ================================================================

      while (true){
         newBroadcast.packageAndSendRadiogram();
         // =============================================================
         // For trouble shooting only
         // -------------------------------------------------------------
         System.out.println("Host broadcasted address");

         try {
            Thread.sleep(30000);
         } catch (InterruptedException ex) {
            Logger.getLogger(BroadcastHostAddress.class.getName()).
                    log(Level.SEVERE, null, ex);
         }
      } // end of WHILE

   } // end of run()

} // end of class
