/* **********************************************************************
 * Author      :  Severin Willisch
 * email       :  d9840087@mail.connect.usq.edu.au
 * Student No. :  0039840087
 * Purpose     :  Project for Semester 1 & 2, 2009
 * Purpose     :  09-036 Programming Sun SPOTs in JAVA
 * **********************************************************************
 */

/* **********************************************************************
 * Purpose     :  This class is used to establish if data received ...
 * Purpose     :  by the host is a status update or environmental data.
 * **********************************************************************
 */

package org.sunspotworld;

import com.sun.spot.io.j2me.radiogram.*;
import javax.microedition.io.*;

class HostIdentifyByByte implements Runnable {

   // ===================================================================
   // Instance variables
   // -------------------------------------------------------------------
   RadiogramConnection rCon = null;
   Datagram dg = null;

   String name;                            // name of thread
   Thread t;
   int portNumber;

   byte byteData = 0;
   double doubleData = 0.0;
   int intData = 0;
   String addr = null;
   String location = null;
   int messageIdentifier = 0;
   // ===================================================================


   HostIdentifyByByte(String threadname, int portNo) {
      name = threadname;
      t = new Thread(this, name);
      portNumber = portNo;
      System.out.println("New thread: " + t);
      t.start();
   }
   
   // +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   // entry point for thread
   // +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   
   public void run() {

      // ================================================================
      // For trouble shooting only
      // ----------------------------------------------------------------
      System.out.println("Start new " + name + " thread on " +
              portNumber);
      // ================================================================

      // ================================================================
      // Start a new listener on host
      // ----------------------------------------------------------------
      CommClassHost hostListener = new CommClassHost();
      // ================================================================

      // ================================================================
      // Intial set up for communication
      // ----------------------------------------------------------------
      hostListener.initBroadcastCom();
      hostListener.setPortNumber(portNumber);
      // ================================================================

      // ================================================================
      // Open up a unicast (broadcast) connection
      // ----------------------------------------------------------------
      hostListener.tryToOpenBroadcastConnection(false);
      // ================================================================

      // ================================================================
      // Main data collection loop
      // ----------------------------------------------------------------
      while (true) {
         // =============================================================
         // listen for new data packet
         // -------------------------------------------------------------
         hostListener.listenFor();
         // =============================================================
         
         // =============================================================
         // Set value for switch case
         // -------------------------------------------------------------
         messageIdentifier = hostListener.getReadDataByte();
         // =============================================================

         if(portNumber == 67){
            // ==========================================================
            // push time, delay and location to terminal for packets ...
            // from collector SPOTs
            // ----------------------------------------------------------
            hostListener.pushTimeAndLocationToTerminal(true);
            // ==========================================================

            // ==========================================================
            // Identify message based on message identifier, data
            // ----------------------------------------------------------
            hostListener.identifyMessageAndPushToTerminal
                    (messageIdentifier);
            // ==========================================================

         } else if(portNumber == 68){
            // ==========================================================
            // push time, delay and location to terminal for packets ...
            // from interface hosts
            // ----------------------------------------------------------
            hostListener.pushTimeAndLocationToTerminal(false);
            // ==========================================================

            // ==========================================================
            // Identify message based on message identifier
            // ----------------------------------------------------------
            hostListener.identifyMessageAndPushToTerminal
                    (messageIdentifier);
            // ==========================================================

         } // end of ELSE IF

      } // end while

   } // end run()
   
} // end class
