/* **********************************************************************
 * Author      :  Severin Willisch
 * email       :  d9840087@mail.connect.usq.edu.au
 * Student No. :  0039840087
 * Purpose     :  Project for Semester 1 & 2, 2009
 * Purpose     :  09-036 Programming Sun SPOTs in JAVA
 * **********************************************************************
 */

/* **********************************************************************
 * Purpose     :  This is the main class for the application used ...
 * Purpose     :  during the test beds. The class launches 3 threads.
 * Purpose     :  Once threads are launched this class waits until ...
 * Purpose     :  all threads are finished. This class runs on the host.
 * **********************************************************************
 */

package org.sunspotworld;

public class IdentMessByByteOnHost {
   // ===================================================================
   // Instance variables
   // -------------------------------------------------------------------
   private static final int HOST_PORT_SEND = 66;
   private static final int HOST_PORT_LISTEN_DATA = 67;
   private static final int HOST_PORT_LISTEN_STATUS = 68;
   // ===================================================================

   public static void main(String[] args) {
      // ================================================================
      // Set the host up to identify information in data packet
      // based.
      // ----------------------------------------------------------------
      BroadcastHostAddress myHostAddress = new BroadcastHostAddress(
              "BroadcastHostAddress", HOST_PORT_SEND);

      HostIdentifyByByte enviroData = new HostIdentifyByByte(
              "EnvironmentalData", HOST_PORT_LISTEN_DATA);

      HostIdentifyByByte statusReport = new HostIdentifyByByte(
              "ExtSysData", HOST_PORT_LISTEN_STATUS);
      // ================================================================

      
      try {
         // =============================================================
         // For trouble shooting only
         // -------------------------------------------------------------
         System.out.println("Wait for thread to finish.");
         // -------------------------------------------------------------
         enviroData.t.join();
         statusReport.t.join();
         myHostAddress.t.join();

      } catch (InterruptedException e) {
         System.out.println("Main thread interrupted.");
      }
      System.out.println("Main thread exiting.");
   }
}

