/* **********************************************************************
 * Author      :  Severin Willisch
 * email       :  d9840087@mail.connect.usq.edu.au
 * Student No. :  0039840087
 * Purpose     :  Project for Semester 1 & 2, 2009
 * Purpose     :  09-036 Programming Sun SPOTs in JAVA
 * **********************************************************************
 */

/* **********************************************************************
 * Purpose     :  This class includes all the specific functions of a ...
 * Purpose     :  door interface mote. A digital output will be used ...
 * Purpose     :  to forward the command to unlock the door.
 * **********************************************************************
 */

package org.sunspotworld;

import com.sun.spot.sensorboard.EDemoBoard;
import com.sun.spot.sensorboard.EDemoController;
import com.sun.spot.sensorboard.io.InputPin;
import com.sun.spot.sensorboard.io.PinDescriptor;
import com.sun.spot.sensorboard.peripheral.ITriColorLED;
import com.sun.spot.util.Utils;

class DoorInterfaceMote extends InterfaceMote{
   // ===================================================================
   // Instance variables
   // -------------------------------------------------------------------
   private PinDescriptor unlockDoorOutput;
   private EDemoBoard doorCommand;
   private EDemoController doorCommandController;
   private InputPin pin;

   private ITriColorLED[] indicateDoorUnlocked = EDemoBoard.
           getInstance().getLEDs();
   // ===================================================================

   // ===================================================================
   // methods to access instance variables, setter methods
   // ===================================================================
   void setPinStatus(InputPin setPin){
      pin = setPin;
   }
   // ===================================================================

   // ===================================================================
   // methods to access instance variables, getter methods
   // ===================================================================
   InputPin getPinStatus(){
      return pin;
   }
   // ===================================================================

   // ===================================================================
   // All other methods
   // ===================================================================
   void initDoorInterface() {
      // ================================================================
      // initialise door unlocking function of mote
      // ----------------------------------------------------------------
      unlockDoorOutput = EDemoController.D2;
      doorCommand = EDemoBoard.getInstance();
      doorCommandController = doorCommand.getEDemoController();
      pin = new InputPin(unlockDoorOutput, doorCommandController);
      doorCommandController.setPinDirection(unlockDoorOutput, true);
      // ================================================================
      
   } // end initLightMeasurement()

   void unlockTheDoor(long unlockDoorTime) {

      // ================================================================
      // Activate one LED to show that door is unlocked
      // ----------------------------------------------------------------
      indicateDoorUnlocked[1].setRGB(0, 0, 255);
      indicateDoorUnlocked[1].setOn();
      // ================================================================

      // ================================================================
      // Set pin to unlock(true)
      // ----------------------------------------------------------------
      doorCommandController.setPinValue(unlockDoorOutput, true);
      // ================================================================

      // ================================================================
      // For trouble shooting only
      // ----------------------------------------------------------------
      System.out.println("Door unlocked");
      // ================================================================

      Utils.sleep(unlockDoorTime);     // door unlocked while mote sleeps

      // ================================================================
      // Set pin to lock(false)
      // ----------------------------------------------------------------
      doorCommandController.setPinValue(unlockDoorOutput, false);
      // ================================================================

      // ================================================================
      // Deactivate LED to show that door is locked
      // ----------------------------------------------------------------
      indicateDoorUnlocked[1].setRGB(0, 0, 255);
      indicateDoorUnlocked[1].setOff();
      // ================================================================

      // ================================================================
      // For trouble shooting only
      // ----------------------------------------------------------------
      System.out.println("Door locked");
      // ================================================================

   } // end of pushDataToExternalSystem()
} // end of class
