/* **********************************************************************
 * Author      :  Severin Willisch
 * email       :  d9840087@mail.connect.usq.edu.au
 * Student No. :  0039840087
 * Purpose     :  Project for Semester 1 & 2, 2009
 * Purpose     :  09-036 Programming Sun SPOTs in JAVA
 * **********************************************************************
 */

/* **********************************************************************
 * Purpose     :  This class runs if the MANIFEST.MF file has door ...
 * Purpose     :  interface as a requirement.
 * Inputs      :  External System Type,
                  port used by host,
                  interface type as a byte
 * **********************************************************************
 */

package org.sunspotworld;

class DoorInterfaceThread implements Runnable{
   // ===================================================================
   // Instance variables
   // -------------------------------------------------------------------
   private String systemInterface;
   private Thread t;
   private int hostPortNumber;
   private long unlockTime;
   private byte interfaceIdAsByte;
   private byte dataIdAsByte = 16;               // identifies unlock door
   private boolean listenForNewDatagram = true;
   // ===================================================================

   DoorInterfaceThread(String threadname, int portNo, byte moteType,
           long doorTime){
      systemInterface = threadname;
      t = new Thread(this, systemInterface);
      hostPortNumber = portNo;
      interfaceIdAsByte = moteType;
      unlockTime = doorTime;
      System.out.println("New thread: " + t);
      t.start();

   } // end constructor

   // ===================================================================
   // methods to access instance variables, setter methods
   // ===================================================================
   void setThread(Thread setThread) {
      t = setThread;
   }

   void setListenForNewDatagram(boolean lisForDgs) {
      listenForNewDatagram = lisForDgs;
   }
   // ===================================================================

   // ===================================================================
   // methods to access instance variables, getter methods
   // ===================================================================
   Thread getThread() {
      return t;
   }

   boolean getListenForNewDatagram() {
      return listenForNewDatagram;
   }
   // ===================================================================

   public void run() {
      // ================================================================
      // For trouble shooting only
      // ----------------------------------------------------------------
      System.out.println("Start interface thread: " +
              systemInterface + " " + interfaceIdAsByte);
      // ================================================================

      // ================================================================
      // start a new door interface mote
      // ----------------------------------------------------------------
      DoorInterfaceMote moteDoor = new DoorInterfaceMote();
      // ================================================================

      // ================================================================
      // get and push IEEE address
      // ----------------------------------------------------------------
      moteDoor.getPushAddress();
      // ================================================================

      // ================================================================
      // Intial set up for communication
      // ----------------------------------------------------------------
      moteDoor.initInterfaceMoteCommunication();
      moteDoor.setPortNumber(hostPortNumber);
      // ================================================================

      // ================================================================
      // Open up a broadcast connection
      // ----------------------------------------------------------------
      moteDoor.tryToOpenBroadcastConnection();
      // ================================================================

      // ================================================================
      // Intial set up to interface with external system
      // ----------------------------------------------------------------
      moteDoor.initDoorInterface();
      // ================================================================

      // ================================================================
      // For trouble shooting only
      // ----------------------------------------------------------------
      System.out.println("Start listening for datagrams on port: " +
              hostPortNumber);
      // ================================================================

      while (listenForNewDatagram) {
         // =============================================================
         // listen for new data packet
         // -------------------------------------------------------------
         moteDoor.listenFor();
         // =============================================================

         // =============================================================
         // Verify that packet has door data
         // -------------------------------------------------------------
         if (moteDoor.getReadDataByte() == dataIdAsByte) {
            // ==========================================================
            // For trouble shooting only
            // ----------------------------------------------------------
            System.out.println("Door data received.");
            // ==========================================================

            // ==========================================================
            // Push new data to external system
            // ----------------------------------------------------------
            moteDoor.unlockTheDoor(unlockTime);
            // ==========================================================

         } // end of if packet has temperature data
         // =============================================================

      } // end of while loop

   } // end run()

} // end class
